import React from "react";

/**
 *
 * Work in progress
 */
/**
// Part of code taken from w3 schools for lens movement
Need to maintain the ratio between lens and main image

Need to maintain the ratio between preview container div and image used for preview

Need to have imagePreview width and height with the same aspect ratio
as the original image

Need to translate in horizontal by the ratio of imagePreview width / img width 
Same translate in vertical by the ration of imagePreview height / img height
**/

const DefaultImgPreview = ({
  moveLens,
  imgContainerDimesions,
  lensDimensions,
  imgDimesions,
  previewLensDimensions,
  previewImgDimensions,
  img,
  previewImg,
  imgRefCallback,
  meshRefCallback,
  imagePreviewRefCallback
}) => {
  return (
    <>
      <div
        className="img-main-container"
        onMouseMove={moveLens}
        style={{
          ...imgContainerDimesions
        }}
      >
        <div
          ref={meshRefCallback}
          className="mesh"
          style={{
            opacity: 0.2,
            position: "absolute",
            backgroundImage: `url(data:image/jpeg;base64,/9j/4AAQSkZJRgABAQAAAQABAAD/2wCEAAkGBxQHEBIPEg8VFRAU…H9MNZyWn3bRhpHiGxEbGu5dIiIGGQAAAAAAAAAEgAAAAAAAAAAAAAAAAAAAAAAAAAAAAA//9k=)`,
            backgroundPosition: "50% center",
            backgroundSize: "2px 2px",
            height: "100px",
            width: "100px",
            ...lensDimensions
          }}
        />
        <img
          style={{
            ...imgDimesions
          }}
          ref={imgRefCallback}
          alt="test"
          src={img}
        />
      </div>
      <div
        // className="img-preview-section-container"
        // ref={imagePreviewRefContainer}
        style={{
          ...previewLensDimensions
        }}
      >
        <img
          ref={imagePreviewRefCallback}
          alt="test-preview"
          src={previewImg}
          style={{
            ...previewImgDimensions
          }}
          className="img-preview-section"
        />
      </div>
    </>
  );
};
interface IOptions {
  imgHeight: number;
  imgWidth: number;
  lensHeight: number;
  lensWidth: number;
  previewLensHeight: number;
  img?: string;
  previewImg?: string;
}

/**
 * useImageZoom hook for zoom of images
 */

function useImageZoom({
  imgHeight,
  imgWidth,
  lensHeight,
  lensWidth,
  previewLensHeight,
  img,
  previewImg
}: IOptions) {
  const [imgElemInState, setimgElemInState] = React.useState(null);
  const [meshElemInState, setmeshElemInState] = React.useState(null);
  const [imagePreviewELemInState, setimagePreviewELemInState] = React.useState(
    null
  );

  const calculateDimensions = React.useCallback(() => {
    const imgToLensRatioHeight = imgHeight / lensHeight;
    const imgToLensRatioWidth = imgWidth / lensWidth;
    const lensDimensionRatio = lensWidth / lensHeight;
    const previewLensWidth = lensDimensionRatio * previewLensHeight;
    const imgPreviewHeight = imgToLensRatioHeight * previewLensHeight;
    const imgPreviewWidth = imgToLensRatioWidth * previewLensWidth;

    return {
      imgHeight,
      imgWidth,
      lensHeight,
      lensWidth,
      previewLensHeight,
      imgPreviewHeight,
      imgPreviewWidth,
      previewLensWidth
    };
  }, [imgHeight, imgWidth, lensHeight, lensWidth, previewLensHeight]);

  const [zoomDimensions, setZoomDimensions] = React.useState(() => {
    return calculateDimensions();
  });

  React.useEffect(() => {
    const newZoomDimensions = calculateDimensions();
    setZoomDimensions(newZoomDimensions);
  }, [
    imgHeight,
    lensHeight,
    imgWidth,
    lensWidth,
    previewLensHeight,
    calculateDimensions
  ]);
  const getCursorPos = React.useCallback(
    e => {
      let a;
      let x = 0;
      let y = 0;
      const img = imgElemInState;
      e = e || window.event;
      /* Get the x and y positions of the image: */
      a = img.getBoundingClientRect();
      /* Calculate the cursor's x and y coordinates, relative to the image: */
      x = e.pageX - a.left;
      y = e.pageY - a.top;
      /* Consider any page scrolling: */
      x = x - window.pageXOffset;
      y = y - window.pageYOffset;
      return { x: x, y: y };
    },
    [imgElemInState]
  );
  const moveLens = React.useCallback(
    e => {
      let pos, x, y;
      /* Prevent any other actions that may occur when moving over the image */
      e.preventDefault();
      /* Get the cursor's x and y positions: */
      const lens = meshElemInState;
      const img = imgElemInState;
      const imgPreview = imagePreviewELemInState;
      const cx = imgPreview.offsetWidth / img.offsetWidth;
      const cy = imgPreview.offsetHeight / img.offsetHeight;
      pos = getCursorPos(e);
      /* Calculate the position of the lens: */
      x = pos.x - lens.offsetWidth / 2;
      y = pos.y - lens.offsetHeight / 2;
      /* Prevent the lens from being positioned outside the image: */
      if (x > img.width - lens.offsetWidth) {
        x = img.width - lens.offsetWidth;
      }
      if (x < 0) {
        x = 0;
      }
      if (y > img.height - lens.offsetHeight) {
        y = img.height - lens.offsetHeight;
      }
      if (y < 0) {
        y = 0;
      }
      /* Set the position of the lens: */
      lens.style.left = x + "px";
      lens.style.top = y + "px";
      /* Display what the lens "sees": */
      let finaltranslateX = x * cx;
      let finaltranslateY = y * cy;

      imgPreview.style.transform = `translate3d(${-finaltranslateX}px, ${-finaltranslateY}px, 0px)`;
    },
    [meshElemInState, imgElemInState, imagePreviewELemInState, getCursorPos]
  );
  /**
   * Need to segregate the state value for better usage of this library
   * imgDimesion
   * lensDimension,
   * previewLensDimension
   * previewImgDimension
   */
  const imgRefCallback = React.useCallback(node => {
    setimgElemInState(node);
  }, []);

  const meshRefCallback = React.useCallback(node => {
    setmeshElemInState(node);
  }, []);

  const imagePreviewRefCallback = React.useCallback(node => {
    setimagePreviewELemInState(node);
  }, []);

  const {
    imgHeight: imgHeightInState,
    imgWidth: imgWidthInState,
    lensHeight: lensHeightInState,
    lensWidth: lensWidthInState,
    previewLensHeight: previewLensHeightInState,
    previewLensWidth: previewLensWidthInState,
    imgPreviewHeight: imgPreviewHeightInState,
    imgPreviewWidth: imgPreviewWidthInState
  } = zoomDimensions;

  /**
   * Segregating the style props for various zoom Ui elements
   */

  const imgContainerDimesions = {
    height: `${imgHeightInState}px`,
    width: `${imgWidthInState}px`,
    position: `relative` as "relative"
  };
  const imgDimesions = {
    height: "100%",
    width: "100%"
  };
  const lensDimensions = {
    height: `${lensHeightInState}px`,
    width: `${lensWidthInState}px`
  };

  const previewLensDimensions = {
    height: `${previewLensHeightInState}px`,
    width: `${previewLensWidthInState}px`,
    overflow: "hidden"
  };
  const previewImgDimensions = {
    height: `${imgPreviewHeightInState}px`,
    width: `${imgPreviewWidthInState}px`
  };

  const DefaultView = DefaultImgPreview({
    moveLens,
    imgContainerDimesions,
    lensDimensions,
    imgDimesions,
    previewLensDimensions,
    previewImgDimensions,
    img,
    previewImg,
    imgRefCallback,
    meshRefCallback,
    imagePreviewRefCallback
  });

  return {
    moveLens,
    imgContainerDimesions,
    imgDimesions,
    lensDimensions,
    previewLensDimensions,
    previewImgDimensions,
    DefaultView,
    imgRefCallback,
    meshRefCallback,
    imagePreviewRefCallback
  };
}
export { useImageZoom };
